/*
  Wrapper to MSISE90 routines:

   SUBROUTINE GTD6(IYD, SEC,ALT,GLAT,GLONG,STL,F107A,F107,AP,MASS,D,T)
*/

%module msise90
%include "typemaps.i"

%typemap(ruby,in) float AP[] {
  int i, len;

  if( TYPE($input) == T_FLOAT) {
      $1 = (float*)malloc(sizeof(float)*7);  /* allocate 7 but use only 1 */
      $1[0] = (float) NUM2DBL($input);
  } else {
      len = RARRAY($input)->len;
      if (len != 7) rb_raise(rb_eRuntimeError, "ap must be a Float or an Array of length==7");
      $1 = (float*)malloc(sizeof(float)*7);
      for (i = 0; i < 7 ; i++){
	  $1[i] = (float) NUM2DBL(rb_Integer(RARRAY($input)->ptr[i]));
      }
  }

}
%typemap (ruby, freearg) float AP[] {
  free($1);
}

%typemap(in, numinputs=0) float *HASH_D () {
       $1 = ALLOCA_N(float, 8);
}
%typemap(argout) float *HASH_D {
  int i, len;
  if(NIL_P($result)) {
      $result = rb_hash_new();
  }
  rb_hash_aset($result, rb_str_new2("He"), rb_float_new((double) $1[0]) );
  rb_hash_aset($result, rb_str_new2("O"), rb_float_new((double) $1[1]) );
  rb_hash_aset($result, rb_str_new2("N2"), rb_float_new((double) $1[2]) );
  rb_hash_aset($result, rb_str_new2("O2"), rb_float_new((double) $1[3]) );
  rb_hash_aset($result, rb_str_new2("Ar"), rb_float_new((double) $1[4]) );
  rb_hash_aset($result, rb_str_new2("rho"), rb_float_new((double) $1[5]) );
  rb_hash_aset($result, rb_str_new2("H"), rb_float_new((double) $1[6]) );
  rb_hash_aset($result, rb_str_new2("N"), rb_float_new((double) $1[7]) );
}

%typemap(in, numinputs=0) float *HASH_T () {
       $1 = ALLOCA_N(float, 2);
}
%typemap(argout) float *HASH_T {
  int i, len;
  if(NIL_P($result)) {
      $result = rb_hash_new();
  }
  rb_hash_aset($result, rb_str_new2("Tex"), rb_float_new((double) $1[0]) );
  rb_hash_aset($result, rb_str_new2("T"), rb_float_new((double) $1[1]) );
}

%typemap(ruby,in) float ARRAY_IN[ANY] {
  int i, len;

  len = RARRAY($input)->len;
  $1 = (float*)malloc(sizeof(float)*$dim0);
  for (i = 0; i < (len<$dim0 ? len : $dim0) ; i++)
    $1[i] = (float) NUM2DBL(rb_Integer(RARRAY($input)->ptr[i]));
  for (; i < $dim0; i++)
    $1[i] = 0;

}
%typemap (ruby, freearg) float ARRAY_IN[ANY] {
  free($1);
}

////////////////////////////////////////////////////////

void gtd6_(int *INPUT,         # IYD
	   float *INPUT,       # SEC
	   float *INPUT,       # ALT
	   float *INPUT,       # GLAT
	   float *INPUT,       # GLONG
	   float *INPUT,       # STL
	   float *INPUT,       # F107A
	   float *INPUT,       # F107
	   float AP[],         # AP
	   int *INPUT,         # MASS
	   float *HASH_D, # D
	   float *HASH_T  # T
	  );

void tselec_(float ARRAY_IN[25]);

/*
%typemap(in, numinputs=0) float ARRAY_OUT[ANY] () {
       $1 = ALLOCA_N(float, $dim0);
}
%typemap(argout, fragment="output_helper") float ARRAY_OUT[ANY] {
  int i, len;
  VALUE out = rb_ary_new();
  for (i = 0; i < $dim0 ; i++) {
      rb_ary_push(out, rb_float_new((double) $1[i]) );
  }
  $result = output_helper($result, out);
}
*/
